#!/usr/bin/python
# -*- coding: latin-1 -*-

from bottle import route, run, template, static_file, request
from settings import Settings
import json, re, os, requests, socket, psutil, sys, time, threading
from urlparse import urlparse

settings = Settings()
loopid = None
UDP_IP = '127.0.0.1'
UDP_PORT = 54545
BUFFER_SIZE = 1024
PAUSE = 0
NEXT = 1
GOTO = 2
SCREENSHOT = 3
RESTART = 4
TEXT = 5
LOOP = 6
clientRunning = False
socketclient = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
print os.path.dirname(os.path.realpath(sys.argv[0]))
os.chdir(os.path.dirname(os.path.realpath(sys.argv[0])))
dev = False
ddonly = False
for arg in sys.argv:
    print arg
    dev = (arg=='dev')
    ddonly = (arg=='ddonly')
    print dev, ddonly
print dev, ddonly
    

def getLocalPlaylist():
    file = open("/etc/xdg/webkiosk/playlist")
    list = file.readlines()
    plist = []
    for item in list:
        if item[0] != "#":
            name = item.split(' ')[0]
            print urlparse(name).path
            if os.path.isdir(urlparse(name).path):
                flist = os.listdir(urlparse(name).path)
                flist.reverse()
                for ditem in flist:
                    list.insert(list.index(item)+1,ditem)
            else:
                item = {"name": name}
                plist.append(item)
    file.close()
    return plist

@route('/control/pause', method="POST")
def play():
    socketclient.sendto(json.dumps({"action": PAUSE}),(UDP_IP,UDP_PORT))
@route('/remote/goto', method="POST")
def goto():
    socketclient.sendto(json.dumps({"action": GOTO, "data": {"index":request.forms['index'], "loop": request.forms["loop"]}}),(UDP_IP,UDP_PORT))
@route('/control/next', method="POST")
def next():
    socketclient.sendto(json.dumps({"action": NEXT}),(UDP_IP,UDP_PORT))
@route('/remote/screenShot', method="POST")
def screenShot():
    socketclient.sendto(json.dumps({"action": SCREENSHOT}),(UDP_IP,UDP_PORT))
@route('/remote/start', method='POST')
def start():
    (url,a,b) = settings.getServer()
    if request.forms['screen'] == 'local':
        settings.setLocal()
    else:
        settings.setChannel(url+'/webapp/p/'+request.forms['screen'])
    socketclient.sendto(json.dumps({"action": RESTART}),(UDP_IP,UDP_PORT))

@route('/res/screen')
def screen():
    if os.uname()[4].startswith("arm") :
        for x in xrange(1,6):
            time.sleep(0.5)
    time.sleep(1)
    return static_file("/tmp/screen.png",root='/');
@route('/remote/text', method="POST")
def text():
    for form in request.forms:
        print form
        pass
    socketclient.sendto(json.dumps({"action": TEXT, "data": {"text":request.forms.get('text')}}), (UDP_IP,UDP_PORT))
@route('/static/<filepath:path>')
def server_static(filepath):
    return static_file(filepath, root='./web')

@route("/info")
def info():
    url = "local"
    invoice = "local"
    if settings.getRemote():
        (url, invoice, email) = settings.getServer()
        headers = {"Content-type": "application/x-www-form-urlencoded; charset=UTF-8","Accept": "application/json"}
        response = requests.post(url+"/webapp/api/user/"+str(invoice),data={"model":json.dumps({"invoice":str(invoice), "email":email})},headers=headers)
        if response.status_code != requests.codes.ok:
            invoice = "public"
    return json.dumps({"url": url, "invoice": invoice})
@route('/remote')
def remote():
    return static_file('remote.html',root='./web')
@route('/remote/channels')
def remote():
    (url, login, password) = settings.getServer()
    headers = {"Content-type": "application/x-www-form-urlencoded; charset=UTF-8","Accept": "application/json"}
    response = requests.post(url+"/webapp/api/user/"+str(login),data={"model":json.dumps({"invoice":str(login), "email":password})},headers=headers)
    if response.status_code != requests.codes.ok:
        response = requests.get(url+"/webapp/db/channels",headers=headers)
    if callable(getattr(response,"json")):
        return json.dumps(response.json())
    else:
        return json.dumps(response.json)
@route('/remote/playlist')
def playlist():
    playlist = ""
    isremote = False
    if(settings.getRemote()):
        file = open('/home/linutop/.linutop-kiosk/playlist')
        playlist = file.read()
        isremote = True
        file.close()
    else:
        playlist = getLocalPlaylist()
    reply =  json.dumps({"playlist":playlist,"remote":isremote})
    return reply
@route('/text')
def text():
    return static_file("text.html", root="./web")
@route('/')
def home():
    if ddonly:
        return text()
    return static_file('index.html',root='./web')

run(host='', port=8080)
