#include <unistd.h>
#include <sys/types.h>

#include <QApplication>
#include <QMessageBox>
#include <QTranslator>

#include "settingsui.h"

int main(int argc, char **argv)
{
    QApplication app(argc, argv);

    QTranslator qtTranslator;
    qtTranslator.load("settings_" + QLocale::system().name(),
                      "/usr/share/linutop-webkiosk/i18n");
    app.installTranslator(&qtTranslator);
    if (geteuid() != 0)
    {
        QMessageBox::warning(NULL, QObject::tr("Root Access Required"),
                    QObject::tr("You need to be root to execute this application."));
        exit(1);
    }
    SettingsDialog d;
    d.show();

    return app.exec();
}

